/*
	file MCalc.java
	jlouie 1.98
	This version of MCalc is an experiment with assertions (AssertionExceptions),
	persistence (using object serialization and backup files)
	and update notification (data binding by attributeName). 
	Tested with Visual Cafe for Java v2.0 (JDK1.13).
	See "Implementing Assertions in Java" by John Hunt and Fred Long
	"Java Developer's Journal" (2:12)pp52-55,1998.
	A Reading List:
	Java:   "Java in a Nutshell" David Flanagan
	        "Core Java" Cornell and Horstmann
	OOP:    "Object-Oriented Analysis and Design" Grady Booch
	        "Object-Oriented Software Construction" Bertrand Meyer
	        "Design Patterns" Gamma et. al.
	Language Ref:   "The Java Language Specification" Gosling, Joy, Steele
	General "Code Complete" Steve McConnell
	
	TO TEST ASSERTIONS: Uncomment the line model.init(0,0,0,0) in doCalc() and
	run the application. Now...
	TO TURN OFF ASSERTIONS: Change the value Assertions.IS_ASSERTIONS_ON to false 
	and recompile Assertion.java. Now run the application again.
	TO TEST PERSISTENCE: Run the program twice and exit with valid data. This will
	create the files MCalc.dat and MCalc.bak. Remove the file MCalc.dat and the file
	MCalc.bak will be opened. Now remove the file MCalc.dat and rename a
	disposable text file to MCalc.dat and run the program. You will see an error 
	message and the file MCalc.bak will be opened.
	TO TEST UPDATE NOTIFICATION: Uncomment the last line in the MCalc constructor 
	and execute the application.
	
	Have fun with Java!
	JeffLouie@compuserve.com
	"A class is like a blueprint for a house. Just as you can build more than one
	house from a blueprint, you can create more than one object from a class. However,
	each house may have different characteristics such as color (properties or attributes).
	Much as a single family dwelling must have a unique mailing address, each runtime 
	object must occupy a unique location in memory. In some languages, one can consider the
	blueprint itself to be an object -- an instance of the class Blueprint <g>."
 */

import java.awt.*;
import java.util.*;
//import symantec.itools.awt.RadioButtonGroupPanel;

public class MCalc extends Frame
{
    //class constants
	public final static int PRINCIPAL= 0;
	public final static int INTEREST= 1;
	public final static int MONTHS= 2;
	public final static int PAYMENT= 3;
	public final static int MESSAGE= 4;
	
	public MCalc()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.

		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(insets().left + insets().right + 377,insets().top + insets().bottom + 208);
		textFieldPrincipal = new java.awt.TextField();
		textFieldPrincipal.setBounds(insets().left + 180,insets().top + 48,156,23);
		add(textFieldPrincipal);
		textFieldInterest = new java.awt.TextField();
		textFieldInterest.setBounds(insets().left + 180,insets().top + 72,155,22);
		add(textFieldInterest);
		textFieldMonths = new java.awt.TextField();
		textFieldMonths.setBounds(insets().left + 180,insets().top + 96,156,23);
		add(textFieldMonths);
		textFieldPayment = new java.awt.TextField();
		textFieldPayment.setBounds(insets().left + 180,insets().top + 120,155,25);
		add(textFieldPayment);
		label1 = new java.awt.Label("Principal ($)");
		label1.setBounds(insets().left + 48,insets().top + 48,108,25);
		add(label1);
		label2 = new java.awt.Label("Annual Interest (%)");
		label2.setBounds(insets().left + 48,insets().top + 72,109,21);
		add(label2);
		label3 = new java.awt.Label("Period (Months)");
		label3.setBounds(insets().left + 48,insets().top + 96,109,26);
		add(label3);
		label4 = new java.awt.Label("Monthly Payment ($)");
		label4.setBounds(insets().left + 48,insets().top + 120,120,24);
		add(label4);
		textFieldMessage = new java.awt.TextField();
		textFieldMessage.setEditable(false);
		textFieldMessage.setBounds(insets().left + 180,insets().top + 12,154,23);
		add(textFieldMessage);
		label5 = new java.awt.Label("MCalc",Label.CENTER);
		label5.setBounds(insets().left + 36,insets().top + 12,121,22);
		label5.setFont(new Font("Dialog", Font.BOLD, 12));
		add(label5);
		buttonCalc = new java.awt.Button();
		buttonCalc.setActionCommand("button");
		buttonCalc.setLabel("Calculate");
		buttonCalc.setBounds(insets().left + 72,insets().top + 168,85,24);
		buttonCalc.setFont(new Font("Dialog", Font.BOLD, 12));
		buttonCalc.setBackground(new Color(12632256));
		add(buttonCalc);
		buttonQuit = new java.awt.Button();
		buttonQuit.setActionCommand("button");
		buttonQuit.setLabel("Quit");
		buttonQuit.setBounds(insets().left + 192,insets().top + 168,86,24);
		buttonQuit.setBackground(new Color(12632256));
		add(buttonQuit);
		setTitle("A Basic Application");
		//}}
		
		// hand code CheckboxGroup to avoid library calls
		// this code will not back parse to the form editor
		radioButtonGroupPanel1 = new java.awt.Panel();
		radioButtonGroupPanel1.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		radioButtonGroupPanel1.setBounds(insets().left + 12,insets().top + 36,25,120);
		add(radioButtonGroupPanel1);
		radioButtonPrincipal = new java.awt.Checkbox("");
		radioButtonPrincipal.setBounds(-2,5,30,23);
		radioButtonPrincipal.setCheckboxGroup(radioGroup);
		radioButtonGroupPanel1.add(radioButtonPrincipal);
		radioButtonInterest = new java.awt.Checkbox("");
		radioButtonInterest.setBounds(-2,33,30,23);
		radioButtonInterest.setCheckboxGroup(radioGroup);
		radioButtonGroupPanel1.add(radioButtonInterest);
		radioButtonMonths = new java.awt.Checkbox("");
		radioButtonMonths.setBounds(-2,61,30,23);
		radioButtonMonths.setCheckboxGroup(radioGroup);
		radioButtonGroupPanel1.add(radioButtonMonths);
		radioButtonPayment = new java.awt.Checkbox("");
		radioButtonPayment.setBounds(-2,89,30,23);
		radioButtonPayment.setCheckboxGroup(radioGroup);
		radioButtonGroupPanel1.add(radioButtonPayment);
		radioButtonPayment.setState(true);

		//{{INIT_MENUS
		mainMenuBar = new java.awt.MenuBar();
		menu1 = new java.awt.Menu("File");
		miExit = new java.awt.MenuItem("Exit");
		menu1.add(miExit);
		mainMenuBar.add(menu1);
		menu2 = new java.awt.Menu("Edit");
		mainMenuBar.add(menu2);
		menu3 = new java.awt.Menu("Help");
		mainMenuBar.setHelpMenu(menu3);
		miAbout = new java.awt.MenuItem("About..");
		menu3.add(miAbout);
		mainMenuBar.add(menu3);
		setMenuBar(mainMenuBar);
		//$$ mainMenuBar.move(12,168);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		miExit.addActionListener(lSymAction);
		miAbout.addActionListener(lSymAction);
		buttonCalc.addActionListener(lSymAction);
		buttonQuit.addActionListener(lSymAction);
		SymMouse aSymMouse = new SymMouse();
		radioButtonPrincipal.addMouseListener(aSymMouse);
		radioButtonInterest.addMouseListener(aSymMouse);
		radioButtonMonths.addMouseListener(aSymMouse);
		radioButtonPayment.addMouseListener(aSymMouse);
		//}}
		
		// user inits
		textFieldTarget= textFieldPayment;
		textFieldTarget.setText("0");
		textFieldTarget.setEnabled(false);
		arrayTextFields[PRINCIPAL]= textFieldPrincipal;
		arrayTextFields[INTEREST]= textFieldInterest;
		arrayTextFields[MONTHS]= textFieldMonths;
		arrayTextFields[PAYMENT]= textFieldPayment;
		arrayTextFields[MESSAGE]= textFieldMessage;
		persistentData= new PersistentData();
		// automagically return a new Model or load an existing Model object from file
		model= persistentData.getModel();
		// bind TextFields to attribute in Model by attributeName
		new TextFieldBinder(textFieldMessage, model, "message");
		new TextFieldBinder(textFieldPrincipal, model, "principal");
		new TextFieldBinder(textFieldInterest, model, "interest");
		new TextFieldBinder(textFieldMonths, model, "months");
		new TextFieldBinder(textFieldPayment,model,"payment");
		// update GUI only if a valid existing Model object exists
		if (model.isValid()) {model.doUpdate();}
		// verify update notification by uncommenting the next line
		//model.init(100000,8,360,0);
	}

	public MCalc(String title)
	{
		this();
		setTitle(title);
	}

	public synchronized void show()
	{
		move(50, 50);
		super.show();
	}

	static public void main(String args[])
	{
		(new MCalc()).show();
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.TextField textFieldPrincipal;
	java.awt.TextField textFieldInterest;
	java.awt.TextField textFieldMonths;
	java.awt.TextField textFieldPayment;
	java.awt.Label label1;
	java.awt.Label label2;
	java.awt.Label label3;
	java.awt.Label label4;
	java.awt.TextField textFieldMessage;
	java.awt.Label label5;
	java.awt.Button buttonCalc;
	java.awt.Button buttonQuit;
	//symantec.itools.awt.RadioButtonGroupPanel radioButtonGroupPanel1;
	java.awt.Checkbox radioButtonPrincipal;
	java.awt.Checkbox radioButtonInterest;
	java.awt.Checkbox radioButtonMonths;
	java.awt.Checkbox radioButtonPayment;
	//}}

	//{{DECLARE_MENUS
	java.awt.MenuBar mainMenuBar;
	java.awt.Menu menu1;
	java.awt.MenuItem miExit;
	java.awt.Menu menu2;
	java.awt.Menu menu3;
	java.awt.MenuItem miAbout;
	//}}
	

	
	//user variables
	CheckboxGroup radioGroup= new CheckboxGroup();
	java.awt.Panel radioButtonGroupPanel1;
	Toolkit tool= Toolkit.getDefaultToolkit();
	TextField textFieldTarget;
	TextField[] arrayTextFields= new TextField[5];
	PersistentData persistentData;
	Model model;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == MCalc.this)
				Frame1_WindowClosing(event);
		}
	}

	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		hide();		 // hide the Frame
		persistentData.saveModel(); // save state of Model
		dispose();	  // free the system resources
		System.exit(0); // close the application
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == miAbout)
				miAbout_Action(event);
			else if (object == miExit)
				miExit_Action(event);
			else if (object == buttonCalc)
				buttonCalc_Action(event);
			else if (object == buttonQuit)
				buttonQuit_Action(event);
		}
	}
	
	void miAbout_Action(java.awt.event.ActionEvent event)
	{
		//{{CONNECTION
		// Action from About Create and show as modal
		(new AboutDialog(this, true)).show();
		//}}
	}

	void miExit_Action(java.awt.event.ActionEvent event)
	{
		//{{CONNECTION
		// Action from Exit Create and show as modal
		(new QuitDialog(this, true)).show();
		//}}
	}
	
	void buttonCalc_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		doCalc();
	}

	void buttonQuit_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		(new QuitDialog(this, true)).show();
		
	}

	
	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == radioButtonPrincipal)
				radioButtonPrincipal_MousePress(event);
			else if (object == radioButtonInterest)
				radioButtonInterest_MousePress(event);
			else if (object == radioButtonMonths)
				radioButtonMonths_MousePress(event);
			else if (object == radioButtonPayment)
				radioButtonPayment_MousePress(event);
		}
	}
	
	void radioButtonPrincipal_MousePress(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		radioButtonPrincipal.setState(true);
		configureTarget(PRINCIPAL);
		textFieldInterest.requestFocus();
	}

	void radioButtonInterest_MousePress(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		radioButtonInterest.setState(true);
		configureTarget(INTEREST);
		textFieldMonths.requestFocus();
	}

	void radioButtonMonths_MousePress(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		radioButtonMonths.setState(true);
		configureTarget(MONTHS);
		textFieldPayment.requestFocus();
	}

	void radioButtonPayment_MousePress(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		radioButtonPayment.setState(true);
		configureTarget(PAYMENT);
		textFieldPrincipal.requestFocus();
	}

    // avoid redundant code
    private void configureTarget(int target) {
        textFieldTarget.setEnabled(true);
        textFieldTarget= arrayTextFields[target];
        textFieldTarget.setText("0");
        textFieldTarget.setEnabled(false);
    }
	
	private void doCalc() {
	    String[] arrayStrings= new String[4];
	    String feedback= "Input Error.";
	    int zeros= 0;
	    String parsed= "Internal Error.";
	    double d= 0.0;
	    Double  tempDouble;
	    double  principal= 0.0;
	    double  interest= 0.0;
	    int     months= 0;
	    double  payment= 0.0;
	    
	    // test model assertions here
	    //model.init(0,0,0,0);
	    //model.init(100000,110,360,0);
	    //model.init(10000,8,-1,0);
	    
	    textFieldTarget.setText("0");
	    for (int i=0; i<4; i++) {
	        arrayStrings[i]= arrayTextFields[i].getText();
	    }
   
        // verify all values are positive and represent a double value
        // verify that only one value is 0
	    for (int i=0; i<4; i++) {
	        parsed= parseString( arrayStrings[i]);
	        try {
    	        tempDouble= Double.valueOf(parsed);
    	        if (tempDouble.isNaN()){throw new NumberFormatException();}
    	        d= tempDouble.doubleValue();
	            if (d <0) {throw new NumberFormatException();}
	            if (d == 0) {zeros +=1;}
	        }
	        catch (NumberFormatException e){
	            beep();
	            arrayTextFields[i].setText("Invalid Entry.");
	            textFieldMessage.setText(feedback);
	            arrayTextFields[i].selectAll();
	            arrayTextFields[i].requestFocus();
	            return;   
	        }
	    }
	    if (zeros >1) {
	        textFieldMessage.setText("Too many zeros.");
	        beep();
	        return;
	    }
	    if (zeros == 0) {
	        textFieldMessage.setText("One entry must be o.");
	        beep();
	        return;
	    }
	    // one text field contains zero.
	    textFieldMessage.setText("");
	    
	    //Principal
	    parsed= parseString(arrayStrings[PRINCIPAL]);
    	tempDouble= Double.valueOf(parsed);
    	d= tempDouble.doubleValue();
	    principal= d;

	    //Interest: Verify value <=100
	    parsed= parseString(arrayStrings[INTEREST]);
	    tempDouble= Double.valueOf(parsed);
    	d= tempDouble.doubleValue();
	    if (d>100){
	        beep();
	        textFieldInterest.setText("Invalid Entry.");
	        textFieldMessage.setText(feedback);
	        textFieldInterest.selectAll();
	        textFieldInterest.requestFocus();
	        return; 
	    }
	    interest= d;

	    //Months: Verify is integer value
	    parsed= parseString(arrayStrings[MONTHS]);
    	tempDouble= Double.valueOf(parsed);
    	d= tempDouble.doubleValue();
	    if ((int)d != d){
	        beep();
	        textFieldMonths.setText("Invalid Entry.");
	        textFieldMessage.setText(feedback);
	        textFieldMonths.selectAll();
	        textFieldMonths.requestFocus();
	        return; 
	    }
	    months= (int)d;
	    
	    //Payment
	    parsed= parseString(arrayStrings[PAYMENT]); 
    	tempDouble= Double.valueOf(parsed);
    	d= tempDouble.doubleValue();
	    payment= d; 
	    
	    model.init(principal,interest, months, payment);
	}		
	
	// strip out commas
	private String parseString(String inString){
        StringBuffer   outString= new StringBuffer(inString.length());

        for (int i=0; i<inString.length(); i++)
        {
            if (inString.charAt(i) != ',')
                {outString.append(inString.charAt(i));}
        }
        return outString.toString();
    }
    
    private void beep() {
        if (tool != null) {tool.beep();}   
    }
}

