// file TextFieldBinder.java
// jlouie 1.98
// binds a TextField to an attribute using a fieldName
// the data source must extend Observable and pass a
// Hashtable with fieldValues indexed by fieldNames.

import java.util.*;
import java.awt.*;

public class TextFieldBinder implements Observer {

        private TextField target;
        private String attributeName= "";
        private boolean isVerifyChange= true;
        private Observable dataSource= null;

        // implement Observer interface
        public void update(Observable obs, Object arg) {
            if ((!(arg instanceof Hashtable))||(target == null)){return;}
            Hashtable hash= (Hashtable)arg;
            Object o= hash.get(attributeName);
            if (!(o instanceof String)) {return;}
            String fieldValue= (String)o;
            if ((isVerifyChange) && (target.getText().equals(fieldValue))){return;}
            target.setText(fieldValue);
        }

        // constructor
        public TextFieldBinder(TextField target, Observable dataSource, String attributeName) {
            this.target= target;
            this.attributeName= attributeName;
            this.dataSource= dataSource;
            if (dataSource != null) {dataSource.addObserver(this);}
        }

        // public getters and setters
        public boolean isVerifyOn() {return isVerifyChange;}
        public void setVerify(boolean isVerifyChange) {
            this.isVerifyChange= isVerifyChange;
        }
        
        // release resources and references
        public void destroy() {
            if (dataSource != null) {dataSource.deleteObserver(this);}
            dataSource= null;
            target= null;
        }

}